;=== Include
!ifndef CP_UTF8
	!define CP_UTF8 65001
!endif
!ifndef CP_ACP
	!define CP_ACP 0
!endif
!define PushAsAnsi '!insertmacro PushAs_ ${CP_ACP}'
!define PushAsUtf8 '!insertmacro PushAs_ ${CP_UTF8}'
!macro PushAs_ ENCODING VAR
	Push ${VAR}
	Exch $0
	Push $1
	System::Call kernel32::WideCharToMultiByte(i${ENCODING},,tr0,i-1,t.r1,i${NSIS_MAX_STRLEN},,)
	Exch
	Pop $0
	Exch $1
!macroend
!define PopAsAnsi '!insertmacro PopAs_ ${CP_ACP}'
!define PopAsUtf8 '!insertmacro PopAs_ ${CP_UTF8}'
!macro PopAs_ ENCODING VAR
	Exch $0
	Push $1
	System::Call kernel32::MultiByteToWideChar(i${ENCODING},,tr0,i-1,t.r1,i${NSIS_MAX_STRLEN})
	Exch
	Pop $0
	Exch $1
	Pop ${VAR}
!macroend
!macro MYXML_VARIABLES
	!ifndef MYXML_VARIABLES
		!define MYXML_VARIABLES
		Var /GLOBAL MYXML_BOM
		Var /GLOBAL MYXML_TEMPFILENAME
		InitPluginsDir
	!endif
	${If} $MYXML_TEMPFILENAME == ''
		GetTempFileName $MYXML_TEMPFILENAME $PLUGINSDIR
	${EndIf}
!macroend
!define xml::LoadFile `!insertmacro xml::LoadFile`
!macro xml::LoadFile _FILE _ERR
	${PushAsAnsi} `${_FILE}`
	xml::_LoadFile /NOUNLOAD
	${PopAsAnsi} ${_ERR}
!macroend
!define xml::RootElement `!insertmacro xml::RootElement`
!macro xml::RootElement _ERR1 _ERR2
	xml::_RootElement /NOUNLOAD
	${PopAsUtf8} ${_ERR1}
	${PopAsAnsi} ${_ERR2}
!macroend
!define xml::XPathNode `!insertmacro xml::XPathNode`
!macro xml::XPathNode _EXPRESSION _ERR
	${PushAsUtf8} `${_EXPRESSION}`
	xml::_XPathNode /NOUNLOAD
	${PopAsAnsi} ${_ERR}
!macroend
!define xml::GetText `!insertmacro xml::GetText`
!macro xml::GetText _ERR1 _ERR2
	xml::_GetText /NOUNLOAD
	${PopAsUTF8} ${_ERR1}
	${PopAsANSI} ${_ERR2}
!macroend
!define xml::SetText `!insertmacro xml::SetText`
!macro xml::SetText _VALUE _ERR
	${PushAsUtf8} ${_VALUE}
	xml::_SetText /NOUNLOAD
	${PopAsAnsi} ${_ERR}
!macroend
!define xml::SaveFile `!insertmacro xml::SaveFile`
!macro xml::SaveFile _FILE _ERR
	${PushAsAnsi} `${_FILE}`
	xml::_SaveFile /NOUNLOAD
	${PopAsAnsi} ${_ERR}
!macroend
!macro MyXMLUTF16ToUTF8_
	Exch $0
	Push $1
	Push $2
	Push $3
	Push $4
	Push $5
	FileOpen $1 $0 r
	FileReadByte $1 $5
	IntCmp $5 0xFF 0 MyXMLUTF16ToUTF8_close
	FileReadByte $1 $5
	IntCmp $5 0xFE 0 MyXMLUTF16ToUTF8_close
	StrCpy $MYXML_BOM FFFE
	FileSeek $1 0 END $2
	FileSeek $1 2 SET
	System::Alloc $2
	Pop $3
	IntOp $2 $2 - 2
	System::Call 'kernel32::ReadFile(i r1, i r3, i r2, t.,)'
	FileClose $1
	System::Call 'kernel32::WideCharToMultiByte(i ${CP_UTF8}, i 0, i r3, i -1, i 0, i 0, n, n) i .r5'
	System::Alloc $5
	Pop $4
	System::Call 'kernel32::WideCharToMultiByte(i ${CP_UTF8}, i 0, i r3, i -1, i r4, i r5, n, n)'
	FileOpen $1 $MYXML_TEMPFILENAME w
	StrCpy $0 $MYXML_TEMPFILENAME
	FileWriteByte $1 0xEF
	FileWriteByte $1 0xBB
	FileWriteByte $1 0xBF
	IntOp $5 $5 - 1
	System::Call 'kernel32::WriteFile(i r1, i r4, i r5, t.,)'
	System::Free $3
	System::Free $4
	MyXMLUTF16ToUTF8_close:
	FileClose $1
	Pop $5
	Pop $4
	Pop $3
	Pop $2
	Pop $1
	Exch $0
!macroend
!macro MyXMLUTF8ToUTF16_
	Exch $0
	Push $1
	Push $2
	Push $3
	Push $4
	Push $5
	StrCmpS $MYXML_BOM FFFE 0 MyXMLUTF8ToUTF16_end
	StrCpy $MYXML_BOM 0
	FileOpen $1 $MYXML_TEMPFILENAME r
	FileSeek $1 0 END $2
	IntOp $2 $2 - 3
	FileSeek $1 3 SET
	System::Alloc $2
	Pop $3
	System::Call 'kernel32::ReadFile(i r1, i r3, i r2, t.,)'
	FileClose $1
	System::Call 'kernel32::MultiByteToWideChar(i ${CP_UTF8}, i 0, i r3, i r2, i 0, i 0) i .r5'
	IntOp $5 $5 * 2
	System::Alloc $5
	Pop $4
	System::Call 'kernel32::MultiByteToWideChar(i ${CP_UTF8}, i 0, i r3, i r2, i r4, i r5)'
	FileOpen $1 $0 w
	FileWriteByte $1 0xFF
	FileWriteByte $1 0xFE
	System::Call 'kernel32::WriteFile(i r1, i r4, i r5, t.,)'
	FileClose $1
	System::Free $3
	System::Free $4
	MyXMLUTF8ToUTF16_end:
	Pop $5
	Pop $4
	Pop $3
	Pop $2
	Pop $1
	Pop $0
!macroend
!define xml::Unload `!insertmacro xml::Unload`
!macro xml::Unload
	xml::_Unload
!macroend
!macro XMLReadTextCall  _FILE _XPATH _VAR
	!verbose push
	!verbose ${_MYXML_VERBOSE}
	Push `${_FILE}`
	Push `${_XPATH}`
	${CallArtificialFunction} XMLReadText_
	Pop ${_VAR}
	!verbose pop
!macroend
!define XMLReadText '!insertmacro XMLReadTextCall'
!macro XMLReadText_
	!insertmacro MYXML_VARIABLES
	Exch $1
	Exch
	Exch $0
	Exch
	Push $2
	Push $0
	${CallArtificialFunction2} MyXMLUTF16ToUTF8_
	Pop $0
	${xml::LoadFile} $0 $2
	IntCmp $2 -1 XMLReadText_error
	${xml::RootElement} $2 $2
	IntCmp $2 -1 XMLReadText_error
	${xml::XPathNode} $1 $2
	IntCmp $2 -1 XMLReadText_error
	${xml::GetText} $0 $2
	IntCmp $2 -1 XMLReadText_error
	Goto XMLReadText_End
	XMLReadText_error:
	SetErrors
	StrCpy $0 ''
	XMLReadText_End:
	Pop $2
	Pop $1
	Exch $0
!macroend
!define XMLWriteText '!insertmacro XMLWriteTextCall'
!macro XMLWriteTextCall _FILE _XPATH _VAR
	Push `${_FILE}`
	Push `${_XPATH}`
	Push `${_VAR}`
	${CallArtificialFunction} XMLWriteText_
!macroend
!macro XMLWriteText_
	!insertmacro MYXML_VARIABLES
	Exch $2
	Exch
	Exch $1
	Exch
	Exch 2
	Exch $0
	Exch 2
	Push $3
	Push $4
	StrCpy $4 $0
	Push $0
	${CallArtificialFunction2} MyXMLUTF16ToUTF8_
	Pop $0
	${xml::LoadFile} $0 $3
	IntCmp $3 -1 XMLWriteText_error
	${xml::RootElement} $3 $3
	IntCmp $3 -1 XMLWriteText_error
	${xml::XPathNode} $1 $3
	IntCmp $3 -1 XMLWriteText_error
	${xml::SetText} $2 $3
	IntCmp $3 -1 XMLWriteText_error
	${xml::SaveFile} $0 $3
	IntCmp $3 -1 XMLWriteText_error
	Push $4
	${CallArtificialFunction2} MyXMLUTF8ToUTF16_
	Goto XMLWriteText_End
	XMLWriteText_error:
	SetErrors
	XMLWriteText_End:
	Pop $4
	Pop $3
	Pop $2
	Pop $1
	Pop $0
!macroend
;=== Defines
!define CLR    `${SET}\CleanerDefinitions.xml`
!define DEFCLR `${DEFDATA}\settings\CleanerDefinitions.xml`
;===
!define DAT    `${SET}\License.dat`
!define DEFDAT `${DEFDATA}\settings\License.dat`
;===
!define RES    `${DATA}\TuRes.dll`
!define DEFRES `${DEFDATA}\TuRes.dll`
;===
!define TRA    `${DATA}\Translations`
!define DEFTRA `${DEFDATA}\Translations`
;===
!define DIR    `${DATA}\${APPNAME}`
!define XML    `${DIR}\Program Options.xml`
!define DEFXML `${DEFDATA}\${APPNAME}\Program Options.xml`
!define XPATH  /TotalUninstall/Options/Interface/Language
;===
!define DB     `${DIR}\Uninstall.db`
!define DEFDB  `${DEFDATA}\${APPNAME}\Uninstall.db`
;===
!define AGENT  `$SYSDIR\Tasks\Total Uninstall Agent`
!define TASK   `SOFTWARE\Microsoft\Windows NT\CurrentVersion\Schedule\TaskCache`
;===
!define ID     `Software\Microsoft\Windows Media\WMSDK\General`
;===
!define SET32  `Kernel32::SetEnvironmentVariable(t "TU", t "TU")`
!define SET64  `Kernel32::SetEnvironmentVariable(t "TU", t "TU64")`
;===
!define REG1   `${TASK}\Tree\Total Uninstall Agent`
!define REG2   `${TASK}\Logon\$0`
!define REG3   `${TASK}\Tasks\$0`
!define REG4   `${TASK}\Tree\Total Uninstall Agent`
;===
!define PFM    `$0\PortableApps.com\PortableAppsPlatform.exe`
;===
Function GetLCID
	!macro _GetLCID _LNG _LCID
		Push ${_LNG}
		Call GetLCID
		Pop ${_LCID}
	!macroend
	!define GetLCID `!insertmacro _GetLCID`
	Exch $0
	StrCmp $0 Arabic 0 +3
	StrCpy $0 1025
		Goto EndLCID
	StrCmp $0 Czech 0 +3
	StrCpy $0 1029
		Goto EndLCID
	StrCmp $0 English 0 +3
	StrCpy $0 1033
		Goto EndLCID
	StrCmp $0 Farsi 0 +3
	StrCpy $0 1065
		Goto EndLCID
	StrCmp $0 French 0 +3
	StrCpy $0 1036
		Goto EndLCID
	StrCmp $0 German 0 +3
	StrCpy $0 1031
		Goto EndLCID
	StrCmp $0 Greek 0 +3
	StrCpy $0 1032
		Goto EndLCID
	StrCmp $0 Hebrew 0 +3
	StrCpy $0 1037
		Goto EndLCID
	StrCmp $0 Indonesian 0 +3
	StrCpy $0 1057
		Goto EndLCID
	StrCmp $0 Italian 0 +3
	StrCpy $0 1040
		Goto EndLCID
	StrCmp $0 Japanese 0 +3
	StrCpy $0 1041
		Goto EndLCID
	StrCmp $0 Korean 0 +3
	StrCpy $0 1042
		Goto EndLCID
	StrCmp $0 Malaysian 0 +3
	StrCpy $0 1086
		Goto EndLCID
	StrCmp $0 Montenegrin 0 +3
	StrCpy $0 2074
		Goto EndLCID
	StrCmp $0 Norwegian 0 +3
	StrCpy $0 1044
		Goto EndLCID
	StrCmp $0 Polish 0 +3
	StrCpy $0 1045
		Goto EndLCID
	StrCmp $0 Portuguese-Brazilian 0 +3
	StrCpy $0 1046
		Goto EndLCID
	StrCmp $0 Romanian 0 +3
	StrCpy $0 1048
		Goto EndLCID
	StrCmp $0 Russian 0 +3
	StrCpy $0 1049
		Goto EndLCID
	StrCmp $0 Chinese-Simplified 0 +3
	StrCpy $0 2052
		Goto EndLCID
	StrCmp $0 Slovenian 0 +3
	StrCpy $0 1060
		Goto EndLCID
	StrCmp $0 Spanish 0 +3
	StrCpy $0 1034
		Goto EndLCID
	StrCmp $0 Swedish 0 +3
	StrCpy $0 1053
		Goto EndLCID
	StrCmp $0 Chinese-Traditional 0 +3
	StrCpy $0 1028
		Goto EndLCID
	StrCmp $0 Ukrainian 0 +3
	StrCpy $0 1058
		Goto +2
	StrCpy $0 1033
	EndLCID:
	Exch $0
FunctionEnd
Function GetLNG
	!macro _GetLNG _LCID _LNG
		Push ${_LCID}
		Call GetLNG
		Pop ${_LNG}
	!macroend
	!define GetLNG `!insertmacro _GetLNG`
	Exch $0
	StrCmp $0 1025 0 +3
	StrCpy $0 Arabic
		Goto EndLNG
	StrCmp $0 1029 0 +3
	StrCpy $0 Czech
		Goto EndLNG
	StrCmp $0 1033 0 +3
	StrCpy $0 English
		Goto EndLNG
	StrCmp $0 1065 0 +3
	StrCpy $0 Farsi
		Goto EndLNG
	StrCmp $0 1036 0 +3
	StrCpy $0 French
		Goto EndLNG
	StrCmp $0 1031 0 +3
	StrCpy $0 German
		Goto EndLNG
	StrCmp $0 1032 0 +3
	StrCpy $0 Greek
		Goto EndLNG
	StrCmp $0 1037 0 +3
	StrCpy $0 Hebrew
		Goto EndLNG
	StrCmp $0 1057 0 +3
	StrCpy $0 Indonesian
		Goto EndLNG
	StrCmp $0 1040 0 +3
	StrCpy $0 Italian
		Goto EndLNG
	StrCmp $0 1041 0 +3
	StrCpy $0 Japanese
		Goto EndLNG
	StrCmp $0 1042 0 +3
	StrCpy $0 Korean
		Goto EndLNG
	StrCmp $0 1086 0 +3
	StrCpy $0 Malaysian
		Goto EndLNG
	StrCmp $0 2074 0 +3
	StrCpy $0 Montenegrin
		Goto EndLNG
	StrCmp $0 1044 0 +3
	StrCpy $0 Norwegian
		Goto EndLNG
	StrCmp $0 1045 0 +3
	StrCpy $0 Polish
		Goto EndLNG
	StrCmp $0 1046 0 +3
	StrCpy $0 Portuguese-Brazilian
		Goto EndLNG
	StrCmp $0 1048 0 +3
	StrCpy $0 Romanian
		Goto EndLNG
	StrCmp $0 1049 0 +3
	StrCpy $0 Russian
		Goto EndLNG
	StrCmp $0 2052 0 +3
	StrCpy $0 Chinese-Simplified
		Goto EndLNG
	StrCmp $0 1060 0 +3
	StrCpy $0 Slovenian
		Goto EndLNG
	StrCmp $0 1034 0 +3
	StrCpy $0 Spanish
		Goto EndLNG
	StrCmp $0 1053 0 +3
	StrCpy $0 Swedish
		Goto EndLNG
	StrCmp $0 1028 0 +3
	StrCpy $0 Chinese-Traditional
		Goto EndLNG
	StrCmp $0 1058 0 +3
	StrCpy $0 Ukrainian
		Goto +2
	StrCpy $0 error
	EndLNG:
	Exch $0
FunctionEnd
;=== Custom.nsh
${SegmentFile}
${Segment.OnInit}
	Push $0
	${IsWOW64} $0
	StrCmp $0 0 0 SixtyFourBit
	System::Call `${SET32}`
	${WriteSettings} 32 Architecture
		Goto End
	SixtyFourBit:
	SetRegView 64
	System::Call `${SET64}`
	${DisableX64FSRedirection}
	${WriteSettings} 64 Architecture
	End:
	Pop $0
!macroend
;===
!macro Lang
	Push $0
	${GetParent} `$EXEDIR` $0
	${If} ${FileExists} `${PFM}`
		ReadEnvStr $0 PortableApps.comLocaleID
		${GetLNG} $0 $0
		${If} $0 == error
			${If} ${FileExists} `${XML}`
				${XMLReadText} `${XML}` ${XPATH} $0
			${Else}
				${XMLReadText} `${DEFXML}` ${XPATH} $0
			${EndIf}
			${GetLCID} $0 $0
			${SetEnvironmentVariable} PortableApps.comLocaleID $0
		${EndIf}
	${Else}
		${If} ${FileExists} `${XML}`
			${XMLReadText} `${XML}` ${XPATH} $0
		${Else}
			${XMLReadText} `${DEFXML}` ${XPATH} $0
		${EndIf}
		${GetLCID} $0 $0
		${SetEnvironmentVariable} PortableApps.comLocaleID $0
	${EndIf}
	Pop $0
!macroend
;===
!macro LangInit
	Push $0
	ReadEnvStr $0 PortableApps.comLocaleID
	${GetLNG} $0 $0
	${SetEnvironmentVariable} PAL:LanguageCustom $0
	Pop $0
!macroend
;===
!macro OS
	Push $0
	${If} ${IsNT}
		${IfNot} ${AtLeastWinXP}
			StrCpy $0 `Windows XP or newer...`
			MessageBox MB_ICONSTOP|MB_TOPMOST `$(MINREQ)`
			Call Unload
			Quit
		${EndIf}
	${Else}
		StrCpy $0 `Windows XP or newer...`
		MessageBox MB_ICONSTOP|MB_TOPMOST `$(MINREQ)`
		Call Unload
		Quit
	${EndIf}
	Pop $0
!macroend
;===
!macro Init
	IfFileExists `${CLR}` +2
	CopyFiles /SILENT `${DEFCLR}` `${CLR}`
	IfFileExists `${DAT}` +2
	CopyFiles /SILENT `${DEFDAT}` `${DAT}`
	IfFileExists `${RES}` +2
	CopyFiles /SILENT `${DEFRES}` `${RES}`
	IfFileExists `${XML}` +3
	CreateDirectory `${DIR}`
	CopyFiles /SILENT `${DEFXML}` `${XML}`
	IfFileExists `${DB}` +2
	CopyFiles /SILENT `${DEFDB}` `${DB}`
	IfFileExists `${TRA}\*.xml` +3
	CreateDirectory `${TRA}`
	CopyFiles /SILENT `${DEFTRA}\*.*` `${TRA}`
!macroend
;===
!macro EnvironmentVariables
	${SetEnvironmentVariable} SYSDIR $SYSDIR
!macroend
;===
!macro PostReg
	Push $0
	ClearErrors
	ReadRegStr $0 HKLM `${REG1}` Id
	${IfNot} ${Errors}
		${SetACL::Key} HKLM `${REG2}`
		DeleteRegKey HKLM `${REG2}`
		${SetACL::Key} HKLM `${REG3}`
		DeleteRegKey HKLM `${REG3}`
		${SetACL::Key} HKLM `${REG1}`
		DeleteRegKey HKLM `${REG1}`
	${EndIf}
	Pop $0
!macroend
;===
${SegmentInit}
	Push $0
	Push $1
	${ReadSettings} $0 LastUniqueID
	ReadRegStr $1 HKCU `${ID}` UniqueID
	${If} $0 != $1
		Delete `${DIR}\*.Cache`
		Delete `${DIR}\System Snapshots\*.*`
	${EndIf}
	Pop $1
	Pop $0
!macroend
;===
${SegmentPrePrimary}
	Push $0
	${File::BackupLocal} `${AGENT}`
	ReadRegStr $0 HKCU `${ID}` UniqueID
	${WriteSettings} $0 LastUniqueID
	Pop $0
!macroend
;===
${SegmentPostPrimary}
	${File::RestoreLocal} `${AGENT}`
!macroend
;===
!macro FileWrite
	Push $0
	Push $1
	Push $2
	Push $3
	StrCpy $0 0
	${Do}
		IntOp $0 $0 + 1
		ClearErrors
		${ReadLauncherConfig} $1 XMLWrite$0 Type
		${IfThen} ${Errors} ${|} ${ExitDo} ${|}
		${If} $1 == `XML text`
			ClearErrors
			${ReadLauncherConfig} $1 XMLWrite$0 File
			${IfThen} ${Errors} ${|} ${ExitDo} ${|}
			${ParseLocations} $1
			ClearErrors
			${ReadLauncherConfig} $2 XMLWrite$0 XPath
			${IfThen} ${Errors} ${|} ${ExitDo} ${|}
			${ParseLocations} $2
			ClearErrors
			${ReadLauncherConfig} $3 XMLWrite$0 Value
			${IfThen} ${Errors} ${|} ${ExitDo} ${|}
			${ParseLocations} $3
			${XMLWriteText} `$1` $2 `$3`
		${EndIf}
	${LoopUntil} ${Errors}
	Pop $3
	Pop $2
	Pop $1
	Pop $0
!macroend
;===
${SegmentUnload}
	${xml::Unload}
!macroend